function o = ApproxEStep( y_, u_, klim, klag, edgesize, insize, outsize )

o = struct;

F = 1;
total = klim+1+1;

T = size(y_, 2);

%using ffts can speed up the computation of the summary statistics (y,y)_k, (u,y)_k, (u,u)_k

fy_y_ = zeros( outsize, outsize, total );

fy = [y_(:,edgesize+1:end-edgesize)'; zeros(klim+1,outsize)];
for i = 1:outsize
    fy(:,i) = fft(fy(:,i));
end

for i = 1:outsize
    for j = 1:outsize
        icy = ifft( conj(fy(:,i)).*fy(:,j) );
        %for k = 0:klim+1
        %    fy_y_(j,i,F+k) = icy(k+1);
        %end
        fy_y_(j,i,:) = icy(1:klim+2);
    end
end


fu_u_ = zeros( insize, insize, total );

fu = [u_(:,edgesize+1:end-edgesize)'; zeros(klim+1,insize)];
for i = 1:insize
    fu(:,i) = fft(fu(:,i));
end

for i = 1:insize
    for j = 1:insize
        icu = ifft( conj(fu(:,i)).*fu(:,j) );
        %for k = 0:klim+1
        %    fu_u_(j,i,F+k) = icu(k+1);
        %end
        fu_u_(j,i,:) = icu(1:klim+2);
    end
end


fu_y_ = zeros( insize, outsize, total );
fy_u_ = zeros( outsize, insize, total );

for i = 1:insize
    for j = 1:outsize
        icuy = ifft(fu(:,i).*conj(fy(:,j)));
        %for k = 0:klim+1
        %    fu_y_(i,j,F+k) = icuy(k+1);
        %end
        fu_y_(i,j,:) = icuy(1:klim+2);
        
        %for k = 1:klim+1
        %    fy_u_(j,i,F+k) = icuy(-k+1+T-2*edgesize+klim+1);
        %end
        fy_u_(j,i,2:end) = icuy((T-2*edgesize+klim+1):-1:(T-2*edgesize+1));
        
    end
end
fy_u_(:,:,F+0) = fu_y_(:,:,F+0)';

u_u_ = fu_u_;
y_y_ = fy_y_;
u_y_ = fu_y_;
y_u_ = fy_u_;


%this accomplishes the same goal as the above code that uses ffts, but less efficiently
%{
y_y_ = zeros( outsize, outsize, total );
u_u_ = zeros( insize, insize, total );
u_y_ = zeros( insize, outsize, total );
y_u_ = zeros( outsize, insize, total );
for k = 0:klim+1
    for t = (edgesize+1):(T-k-edgesize)
        y_y_(:,:,F+k) = y_y_(:,:,F+k) + y_(:,t+k)*y_(:,t)';
        u_u_(:,:,F+k) = u_u_(:,:,F+k) + u_(:,t+k)*u_(:,t)';
        u_y_(:,:,F+k) = u_y_(:,:,F+k) + u_(:,t+k)*y_(:,t)';
        y_u_(:,:,F+k) = y_u_(:,:,F+k) + y_(:,t+k)*u_(:,t)';
    end
end
%}


o.klag = klag;
o.edgesize = edgesize;

o.y_lead_ = y_(:,1:edgesize);
o.u_lead_ = u_(:,1:edgesize);
o.y_trail_ = y_(:,T-edgesize+1:T);
o.u_trail_ = u_(:,T-edgesize+1:T);

o.y_pre_ = y_(:,edgesize+1:edgesize+klag);
o.u_pre_ = u_(:,edgesize+1:edgesize+klag);
o.y_post_ = y_(:,T-klag+1-edgesize:T-edgesize);
o.u_post_ = u_(:,T-klag+1-edgesize:T-edgesize);

o.klim = klim;
o.y_y_ = y_y_;
o.u_u_ = u_u_;
o.u_y_ = u_y_;
o.y_u_ = y_u_;
o.y_ = y_;
o.u_ = u_;
o.T = T;

o = class( o, 'ApproxEStep' );

end