function [expt, LL, perror] = ExactEstep( y_, u_, params )

T = size(y_,2);

[A,B,C,D,Q,R,insize,outsize,hidsize,pi_1,V_1] = pextract( params );

V0 = zeros( hidsize, hidsize, T );
x0 = zeros( hidsize, T );
x1 = zeros( hidsize, T );
xT = zeros( hidsize, T );

LL = 0;
perror = 0;

x1(:,1) = pi_1;
V1 = V_1;
for t = 1:T
    if t > 1
        x1(:,t) = A*x0(:,t-1) + B*u_(:,t-1);
        V1 = A*V0(:,:,t-1)*A' + Q;
    end
    invS = inv(C*V1*C' + R);
    y_inov = y_(:,t) - C*x1(:,t) - D*u_(:,t);
    LL = LL - y_inov'*invS*y_inov / 2;
    LL = LL - outsize*log(2*pi)/2 + logdet(invS)/2;
    perror = perror + y_inov'*y_inov;
    
    K = V1*C'*invS;
    x0(:,t) = x1(:,t) + K*y_inov;
    V0(:,:,t) = V1 - K*C*V1;
end


xT(:,T) = x0(:,T);
VT = V0(:,:,T);
VcSum = zeros(hidsize, hidsize);
VTSum = VT;
for t = T:-1:2
    V1 = A*V0(:,:,t-1)*A' + Q;
    J = V0(:,:,t-1)*A'*inv(V1);
    VcSum = VcSum + VT*J';
    xT(:,t-1) = x0(:,t-1) + J*(xT(:,t) - x1(:,t));
    VT = V0(:,:,t-1) + J*(VT - V1)*J';
    VTSum = VTSum + VT;
end


%% Compute final outputs of E-step

Exx_.start = xT(:,1)*xT(:,1)' + VT;
Exx_.end = xT(:,T)*xT(:,T)' + V0(:,:,T);

Ey_x_0 = y_*xT';

Eu_x_0 = u_*xT';

Ex_u_1 = xT(:,2:end)*u_(:,1:end-1)';

Ex_x_0 = xT*xT' + VTSum;

Ex_x_1 = xT(:,2:end)*xT(:,1:end-1)' + VcSum;


expt = estruct( Ex_x_0, Ex_x_1, Ey_x_0, Eu_x_0, Ex_u_1, xT, Exx_, x1 );
end

