function y_ = GenerateSequence2( seed, u_, params, T )

if seed ~= 0
    randn('state', seed );
    rand('twister', seed+1 );
end


[A,B,C,D,Q,R,insize,outsize,hidsize,pi_1,V_1] = pextract( params );

cQ = chol(Q);
cR = chol(R);
cV_1 = chol(V_1);


x_cur = cV_1*randn(hidsize,1) + pi_1;
y_ = zeros( outsize, 1 );
for t = 1:T
    y_(:,t) = C*x_cur + D*u_(:,t) + cR*randn(outsize,1);
    if t < T
        x_cur = A*x_cur + B*u_(:,t) + cQ*randn(hidsize,1);
    end
end

end