function runTests(name, y_, u_, iparams, numiters, sampleperiod, method, klims, doSS, doclassic, dohist, dotime )


numtest = size(klims,2) + (doSS~=0) + (doclassic~=0);
times = zeros(numtest,1);

if dohist
    LLhist = zeros(numiters/sampleperiod, numtest);
    errhist = zeros(numiters/sampleperiod, numtest);

    for i = 1:size(klims,2)
        [params, LLhist(:,i), errhist(:,i)] = ApproxEMforLDS( y_, u_, iparams, [], numiters, 1, 1, 1, klims(i), sampleperiod, method );
    end
    i = size(klims,2);
    if doSS
        i = i+1;
        if strcmp(method, 'SS')
            tic;
        end
        
        [params, LLhist(:,i), errhist(:,i)] = EMforLDS( y_, u_, iparams, numiters, 1, 1, 1, 1, sampleperiod, method );
        
        if strcmp(method, 'SS')
            times(i) = toc;
        end
    end
    if doclassic
        i = i+1;
        if strcmp(method, 'exact')
            tic;
        end
        
        [params, LLhist(:,i), errhist(:,i)] = EMforLDS( y_, u_, iparams, numiters, 1, 1, 1, 0, sampleperiod, method );
        
        if strcmp(method, 'exact')
            times(i) = toc;
        end
    end

    save( [name '_LLhist'], 'LLhist' );
    save( [name '_errhist'], 'errhist' );
end

%we do the timed runs seperately so that the cost of the extra exact-LL computation isn't factored in
if dotime
    for i = 1:size(klims,2)
        tic;
        ApproxEMforLDS( y_, u_, iparams, [], numiters, 1, 1, 1, klims(i) );
        times(i) = toc;
    end
    i = size(klims,2);
    if doSS && (~strcmp(method, 'SS') || ~dohist)
        i = i+1;
        tic;
        EMforLDS( y_, u_, iparams, numiters, 1, 1, 1, 1 );
        times(i) = toc;
    end
    if doclassic && (~strcmp(method, 'exact') || ~dohist)
        i = i+1;
        tic;
        EMforLDS( y_, u_, iparams, numiters, 1, 1, 1, 0 );
        times(i) = toc;
    end

    save( [name '_runtimes'], 'times' );
end