function run_evaporator

seed = 123;

load evaporator

%data = data - repmat( sum(data)/size(data,1), [size(data,1) 1] );

T = size(data,1);

insize = 3;
outsize = 3;
hidsize = 15;
u_ = data(:,1:3)';
y_ = data(:,4:6)';

%we are not using the input (u) data:
insize = 0;
u_ = zeros(insize,T);

iparams = RandomInitialParams( seed, insize, outsize, hidsize );

runTests('evaporator', y_, u_, iparams, 600, 5, 'exact', [5 10 20 35 75], 1, 1, 1, 1 );


times = [];
load evaporator_LLhist
load evaporator_errhist
load evaporator_runtimes
LLhist = LLhist(2:2:end,:); %this is here so that the points appear more spaced out in the plot
plotTests('Negative Log Likelihood', 10, [5 10 20 35 75], 1, 1, -LLhist, times );
figure
plotTests('RMS Prediction Error', 5, [5 10 20 35 75], 1, 1, errhist, times );
