function run_motion

load graham_motion_data

insize = 0;
y_ = data';

%only the first 10 dimensions:
y_ = y_(1:10,:);
outsize = 10;
hidsize = 40;

T = size(y_,2);
u_ = zeros(insize,T);

seed = 123;

iparams = RandomInitialParams( seed, insize, outsize, hidsize );

runTests('motion', y_, u_, iparams, 450, 5, 'exact', [20 30 50], 1, 1, 1, 1 );

times = [];
load motion_LLhist
load motion_errhist
load motion_runtimes
LLhist = LLhist(2:2:end,:); %this is here so that the points appear more spaced out in the plot
plotTests('Negative Log Likelihood', 10, [20 30 50], 1, 1, -LLhist, times );
figure
plotTests('RMS Prediction Error', 5, [20 30 50], 1, 1, errhist, times );

